Skip to main content
`Ctrl`+`K`

# MatQRFactorSymbolic

Performs symbolic QR factorization of matrix. Call this routine after `MatGetFactor()` but before calling `MatQRFactorNumeric()`.

## Synopsis

    #include "petscmat.h"
    PetscErrorCode MatQRFactorSymbolic(Mat fact, Mat mat, IS col, const MatFactorInfo *info)

Collective

## Input Parameters

- fact - the factor matrix obtained with `MatGetFactor()`

- mat - the matrix

- col - column permutation

- info - options for factorization, includes

              fill - expected fill as ratio of original fill.
              dtcol - pivot tolerance (0 no pivot, 1 full column pivoting)
                       Run with the option -info to determine an optimal value to use

## Note

Most users should employ the `KSP` interface for linear solvers instead of working directly with matrix algebra routines such as this. See, e.g., `KSPCreate()`.

## Fortran Note

A valid (non-null) `info` argument must be provided

## See Also

Matrices, `Mat`, Matrix Factorization, `MatGetFactor()`, `MatFactorInfo`, `MatQRFactor()`, `MatQRFactorNumeric()`, `MatLUFactor()`, `MatFactorInfoInitialize()`

## Level

developer

## Location

src/mat/interface/matrix.c

## Implementations

MatQRFactorSymbolic_SPQR() in src/mat/impls/aij/seq/spqr/aijspqr.c
MatQRFactorSymbolic_SeqDense() in src/mat/impls/dense/seq/dense.c

Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages